Skip to main content Skip to footer

How to Import and Export Excel XLSX Using JavaScript

Quick Start Guide
What You Will Need

NPM Packages:

Controls Referenced

SpreadJS - JavaScript SpreadSheet Component

Documentation | Demos

Tutorial Concept Importing, modifying, and exporting Excel (.xlsx) files within JavaScript applications.

Many companies rely on spreadsheets, more specifically Microsoft Excel, to help run their business. Whether these are internal spreadsheets or spreadsheets supplied by their customers, it is crucial that these spreadsheets can still be accessed and/or maintained in your JavaScript applications when moving them to the web.

This blog will introduce how you can easily import Excel files in a familiar spreadsheet UI, programmatically make any changes  or allow your user to make edits, then export them back out to an Excel file using the popular SpreadJS client-side JavaScript spreadsheet component.

Add complete JavaScript spreadsheets into your enterprise web apps. Download SpreadJS Now!

In this blog, we will cover how to import/export to Excel in JavaScript following these steps:

  1. Set Up the JavaScript Spreadsheet Project
  2. Add Excel Import Code
  3. Add Data to the Imported Excel File
  4. Add a Sparkline
  5. Add Excel Export Code

Import and Export Excel (.xlsx files) in JavaScript Apps

Download the sample application to follow along with the blog

Set Up the JavaScript Spreadsheet Project

To start, we can use the SpreadJS files hosted on NPM. To do this, we can install using a command line argument. Open a command prompt and navigate to the location of your application. There, you can install the required files with one command.

In this case, we need the base Spread-Sheets library, Spread-Sheets-IO, FileSaver and jQuery:

npm i @mescius/spread-sheets @mescius/spread-sheets-io file-saver jquery

SpreadJS isn’t dependent on jQuery, but in this case, we use it for the easy cross-origin-request support, which we will review later. We will also need the FileSaver library, an external library to allow users to save the files where they want, which we have imported in addition to the SpreadJS and jQuery files.

Once those are installed, we can add references to those script and CSS files in a simple HTML file like so:

<!DOCTYPE html>  
<html>  
<head>  
    <title>SpreadJS Import and Export Xlsx</title>
    <script src="./node_modules/jquery/dist/jquery.min.js" type="text/javascript"></script>
    <script src="./node_modules/file-saver/src/FileSaver.js" type="text/javascript"></script>
    <link href="./node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="./node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js"></script>
    <script  type="text/javascript" src="./node_modules/@mescius/spread-sheets-io/dist/gc.spread.sheets.io.min.js"></script>
</head>  
<body>  
    <div id="ss" style="height:600px; width :100%; "></div>  
</body>  
</html>  

Then we can add a script to the page that initializes the SpreadJS Workbook component and a div element to contain it (since the SpreadJS spreadsheet component utilizes a canvas, this is necessary to initialize the component):

    <script type="text/javascript">  
        $(document).ready(function () {  
            var workbook = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));  
        });  
    </script>  
</head>  
<body>  
    <div id="ss" style="height:600px ; width :100%; "></div>  
</body>  

Add Excel Import Code

We need to add an input element and a button to allow users to select their Excel (XLSX) file.

<body>
    <div id="ss" style="height:700px; width:100%;"></div>
    <input type="file" id="selectedFile" name="files[]" accept=".xlsx" />
    <button class="settingButton" id="open">Open</button>
</body>

Then we need to add a function to import a file using spreads import method. In this example, we will import the user selected local file in the click event handler for the open button.

document.getElementById('open').onclick = function () {
     var file = document.querySelector('#selectedFile').files[0];
         if (!file) {
             return;
         }
     workbook.import(file);
};

 You can do the same thing with an Excel file on a server by reading it from a URL.

An Excel (.xlsx) file can now be imported and viewed in the JavaScript spreadsheet component like so:

Import an Excel xlsx file in a JS application


Add Data to the Imported Excel File

For this tutorial we will use the “Profit loss statement” Excel template seen here:

“Profit loss statement” Excel template

Now we can use Spread.Sheets script to add another revenue line into this file. Let’s add a button to the page that will do just that:

<button id="addRevenue">Add Revenue</button>  

We can write a function for the click event handler for that button to add a row and copy the style from the previous row in preparation for adding some data. To copy the style, we will need to use the copyTo function and pass in:

  • the origin and destination row and column indices
  • row and column count
  • the CopyToOptions value for style
document.getElementById("addRevenue").onclick = function () {  
    var sheet = workbook.getActiveSheet();  
    sheet.addRows(newRowIndex, 1);  
    sheet.copyTo(10, 1, newRowIndex, 1, 1, 29, GC.Spread.Sheets.CopyToOptions.style);  
}  

The following script code for adding data and a Sparkline will be contained within this button click event handler. For most of the data, we can use the setValue function. This allows us to set a value in a sheet in Spread by passing in a row index, column index, and value:

var cellText = "Revenue" + revenueCount++;
sheet.setValue(newRowIndex, 1, cellText);

for (var c = 3; c < 15; c++) {  
    sheet.setValue(newRowIndex, c, Math.floor(Math.random() * 200) + 10);  
}  

Set a SUM formula in column P to match the other rows and set a percentage for column Q:

sheet.setFormula(newRowIndex, 15, "=SUM([@[Jan]:[Dec]])")  
sheet.setValue(newRowIndex, 16, 0.15);  

Lastly, we can copy the formulas from the previous rows to the new row for columns R through AD using the copyTo function again, this time using CopyToOptions.formula:

sheet.copyTo(10, 17, newRowIndex, 17, 1, 13, GC.Spread.Sheets.CopyToOptions.formula);  

Add a Sparkline

Now we can add a sparkline to match the other rows of data. To do this, we need to provide a range of cells to get the data from and some settings for the sparkline. In this case, we can specify:

  • the range of cells we just added data to
  • settings to make the sparkline look like the other sparklines in the same column
var data = new GC.Spread.Sheets.Range(newRowIndex, 3, 1, 12);  
var setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();  
setting.options.seriesColor = "Text 2";  
setting.options.lineWeight = 1;  
setting.options.showLow = true;  
setting.options.showHigh = true;  
setting.options.lowMarkerColor = "Text 2";  
setting.options.highMarkerColor = "Text 1";  

After that, we call the setSparkline method and specify:

  • a location for the sparkline
  • the location of the data
  • the orientation of the sparkline
  • the type of sparkline
  • the settings we created
sheet.setSparkline(newRowIndex, 2, data, GC.Spread.Sheets.Sparklines.DataOrientation.horizontal, GC.Spread.Sheets.Sparklines.SparklineType.line, setting);  

If you were to try running the code now, it might seem a little slow because the workbook is repainting every time data is changed and styles are added. To drastically speed it up and increase performance, Spread.Sheets provide the ability to suspend painting and the calculation service. Let’s add the code to suspend both before adding a row and its data and then resume both after:

workbook.suspendPaint();  
workbook.suspendCalcService();  
//...  
workbook.resumeCalcService();  
workbook.resumePaint();  

Once we add that code, we can open the page in a web browser and see the Excel file load into Spread.Sheets with an added revenue row. 

Programmatically Add Data to an Excel File using JavaScript


Add Excel Export Code

Finally, we can add a button to export the file with the added revenue row/s. To handle this, we can invoke the export method built into Spread.Sheets in the export button on click event handler:

            document.getElementById("export").onclick = function () {
                var fileName = $("#exportFileName").val();
                if (fileName.substr(-5, 5) !== '.xlsx') {
                    fileName += '.xlsx';
                }
                var json = JSON.stringify(workbook.toJSON());
                workbook.export(function (blob) {
                    // save blob to a file
                    saveAs(blob, fileName);
                }, function (e) {
                    console.log(e);
                }, {
                    fileType: GC.Spread.Sheets.FileType.excel
                });
            }

That code gets the export file name from an exportFileName input element. We can define it and let users name the file like so:

<input type="text" id="exportFileName" placeholder="Export file name" value="export.xlsx" />  

Then we can add a button that calls this function:

<button id="export">Export File</button>  

Once you add a revenue row, you can export the file using the Export File button. 

When the file is successfully exported, you can open it in Excel and see that the file looks like it did when it was imported, except there is now an extra revenue line that we added.

Export Excel (.xlsx) from JavaScript Apps

This is just one example of how you can use SpreadJS JavaScript spreadsheets to add data to your Excel files and then export them back to Excel with simple JavaScript code.

Download the blog sample here.


Learn More About this JavaScript Spreadsheet Component

This article only scratches the surface of the full capabilities of SpreadJS, the JS spreadsheet component. Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code. Integrating a spreadsheet component into your applications allows you to customize your users' experience and provide them with familiar spreadsheet functionality without referring them to an external program. To learn more about SpreadJS and the new features added in the latest release check out our release pages and this video:

In another article series, we demonstrate how to import/export Excel (.xlsx) spreadsheets in other JavaScript frameworks:

Add complete JavaScript spreadsheets into your enterprise web apps. Download SpreadJS Now!

Tags:

comments powered by Disqus

Skip to main content Skip to footer

How to Import and Export Excel XLSX Using React

Quick Start Guide
Tutorial Concept Learn how to import, modify, and export Excel (.xlsx) files in React applications.
What You Will Need

React v18
NPM Packages:

Controls Referenced

SpreadJS - React Spreadsheet Component
Documentation | Demos

Many businesses utilize spreadsheets, particularly Microsoft Excel, to aid in managing their operations. Whether these are internal spreadsheets or ones provided by clients, it is essential that these files can be accessed and/or managed within React applications.

This article outlines how to seamlessly import Excel files into a user-friendly spreadsheet interface, make modifications programmatically or enable user edits, and export the updated data back into an Excel file with the widely-used SpreadJS client-side React spreadsheet component.

Add React spreadsheets into your enterprise web apps. Download SpreadJS Now!

How to Import and Export Excel (.XLSX) Files in React Applications

  1. Create a React Spreadsheet Application
  2. Add Excel Import Code
  3. Update the Imported XLSX
  4. Add Excel Export Code

Import and Export Excel .XLSX Using React

Download the sample application to follow along with the blog.

Create a React Spreadsheet Application

Create a React Project by opening the Command Prompt window and typing the following commands:

npx create-react-app sjs-react-io
cd sjs-react-io
npm start

Next, install the necessary SpreadJS modules in your project using the following command:

npm install @mescius/spread-sheets @mescius/spread-sheets-react @mescius/spread-sheets-io @mescius/spread-sheets-charts @mescius/spread-sheets-shapes

Import the SpreadJS CSS in your apps index.js file using the following code:

import '@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css';

In the App.js file, declare the imports of the MESCIUS components. These Imports will enable access to the React Spreadsheets object of the SpreadJS library and support for charts, shapes, and import/expo in the spreadsheet instance.

import React, { Component } from "react";
import { SpreadSheets } from "@mescius/spread-sheets-react";
import * as GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-charts";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-io";

Inside the render() function of the App component, add the React Spreadsheets component to display the spreadsheet instance. Additionally, add an input field and buttons for file-handling operations. Define methods for handling file operations such as saving, opening, changing the imported file, and adding data. Placeholder logic will be added for now:

class App extends Component {
  constructor(props) {
    super(props);
    this.hostStyle = {
      width: "950px",
      height: "600px",
    };
    this.spread = null;
  }
  render() {
    return (
      <div style={{ display: "flex" }}>
        <div style={{ width: "950px", height: "600px" }}>
          <SpreadSheets
            workbookInitialized={(spread) => this.initSpread(spread)}
            hostStyle={this.hostStyle}
          ></SpreadSheets>
        </div>
        <div style={{ width: "200px", padding: "20px", background: "#ddd" }}>
          <p>Open Excel Files (.xlsx)</p>
          <input type="file" onChange={this.handleFileChange} />
          <button onClick={this.handleOpenExcel}>Open Excel</button>
          <p>Add Data</p>
          <button onClick={this.handleAddData}>Add Customer</button>
          <p>Save File</p>
          <button onClick={this.handleSaveExcel}>Save Excel</button>
        </div>
      </div>
    );
  }
  initSpread(spread) {
    this.spread = spread;
    this.spread.setSheetCount(2);
    console.log(this.spread);
  }
  handleSaveExcel = () => {
    // Logic to save to Excel
  };
  handleOpenExcel = () => {
    // Logic to import an Excel file
  };
  handleFileChange = (e) => {
    // Logic to change the imported file
  };
  handleAddData = () => {
    // Logic to add data
  };
}
export default App;

Save all the files, and run the React app:

npm start

You have now created a React Spreadsheet app:

Import/Export Excel/XLSX React


Add Excel Import Code to a React App

In the constructor, initialize the state with selectedFile set to null, indicating that no file is selected initially. The handleFileChange function correctly captures the selected Excel file when it's changed and updates the component's state with the selected file.

constructor(props) {
    super(props);
    this.hostStyle = {
      width: "950px",
      height: "600px",
    };
    this.spread = null;
    this.state = {
      selectedFile: null,
    };
    this.currentCustomerIndex = 0;
  }
...
handleFileChange = (e) => {
    this.setState({
      selectedFile: e.target.files[0],
    });
  };

The handleOpenExcel function is triggered when the user clicks the "Open Excel" button. It first checks if a file is selected. If not, it returns early. If a file is selected, it constructs import options specifying the FileType as excel. Then, it calls the import method of the SpreadJS instance (this.spread) with the selected file and import options.

handleOpenExcel = () => {
    const file = this.state.selectedFile;
    if (!file) {
      return;
    }
    // Specify the file type to ensure proper import
    const options = {
      fileType: GC.Spread.Sheets.FileType.excel,
    };
    this.spread.import(
      file,
      () => {
        console.log("Import successful");
      },
      (e) => {
        console.error("Error during import:", e);
      },
      options
    );
  };

Alternatively, you can read an Excel file from a URL on a server. See our blog here.

Run the app and notice an Excel (.xlsx) file can now be imported and viewed in the React spreadsheet component like so:

Import/Export Excel/XLSX React


Update XLSX File Programmatically in a React app

After successfully importing an Excel file into SpreadJS, users can easily interact with the spreadsheet data. Alternatively, you may need to programmatically modify the data within the spreadsheet. This can be accomplished by utilizing SpreadJS’s comprehensive API.

This section introduces the function handleAddData, which adds new customer data to the imported .xlsx file data when clicking a button. First, we need to create a currentCustomerIndex variable, this will be used as a counter related to the sample data:

 handleAddData = () => {
    // Create new row and copy styles
    var newRowIndex = 34;
    var sheet = this.spread.getActiveSheet();
    sheet.addRows(newRowIndex, 1);
    sheet.copyTo(
      32,
      1,
      newRowIndex,
      1,
      1,
      11,
      GC.Spread.Sheets.CopyToOptions.style
    );
    // Define sample customer data
    var customerDataArrays = [
      ["Jessica Moth", 5000, 2000, 3000, 1300, 999, 100],
      ["John Doe", 6000, 2500, 3500, 1400, 1000, 20],
      ["Alice Smith", 7000, 3000, 4000, 1500, 1100, 0],
    ];
    // Get the current customer data array
    var currentCustomerData = customerDataArrays[this.currentCustomerIndex];
    // Add new data to the new row
    sheet.setArray(newRowIndex, 5, [currentCustomerData]);
    newRowIndex++;
    // Increment the index for the next button click
    this.currentCustomerIndex =
      (this.currentCustomerIndex + 1) % customerDataArrays.length;
  };

Notice that new customer data is added to the statement when the button is clicked, and the formulas within the worksheet update accordingly.

Import/Export Excel/XLSX React


Add Excel Export Code to a React App

With the export method included with SpreadJS and the file-saver npm package, React app developers can effortlessly export a spreadsheet state as an Excel file. First, install the file-saver npm package.

npm install file-saver --save
npm i --save-dev @types/file-saver

Import the file-saver package to the App.js file.

import React, { Component } from "react";
import { SpreadSheets } from "@mescius/spread-sheets-react";
import * as GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-charts";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-io";
import { saveAs } from "file-saver";
...

Update the handleSaveExcel function by specifying the exported XLSX file name, “Excel_Export.xlsx”, then invoke the SpreadJS export method. This method exports the React spreadsheet state into a Blob. Within the export method, invoke the file-saver's saveAs method to save the exported spreadsheet Blob as an actual Excel file on the client-side.

  handleSaveExcel = () => {
    var fileName = "Excel_Export.xlsx";
    this.spread.export(
      function (blob) {
        // save blob to a file
        saveAs(blob, fileName);
      },
      function (e) {
        console.log(e);
      },
      {
        fileType: GC.Spread.Sheets.FileType.excel,
      }
    );
  };

You've successfully added Excel export functionality to the React spreadsheet application with these steps.

Import/Export Excel/XLSX React


Learn More About React Spreadsheet Components

This article only scratches the surface of the full capabilities of SpreadJS, the React spreadsheet component. Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code. Integrating a spreadsheet component into your applications allows you to customize your users' experience and provide them with familiar spreadsheet functionality without referring them to an external program. 

Ready to add React spreadsheets into your enterprise web apps? Download SpreadJS Now!

Check out our video to learn more:

In another article series, we demonstrate how to import/export Excel (.xlsx) spreadsheets in other frameworks:

Tags:

comments powered by Disqus

Skip to main content Skip to footer

How to Import and Export Excel XLSX Using Angular

Quick Start Guide
Tutorial Concept Learn how to import, modify, and export Excel (.xlsx) files in Angular applications.
What You Will Need

Angular 16
NPM Packages:

Visual Studio Code

Controls Referenced

SpreadJS – Angular Spreadsheet Component

Documentation | Demos

This article demonstrates how you can import and export Excel spreadsheets in an Angular environment using an Angular spreadsheet component; in this example, that will be SpreadJS. SpreadJS offers Angular developers a familiar Excel-like spreadsheet UI and import/export capabilities without any dependencies on Microsoft Excel.

Ready to Try It Out? Download SpreadJS Today!

How to Import and Export Excel (.XLSX) Files in Angular Applications

  1. Create an Angular Spreadsheet Application
  2. Add Excel Import Code
  3. Add Data to the Imported Excel File
  4. Add Excel Export Code

Import and Export Excel .XLSX from Angular Apps

Download the sample application to follow along with the blog.

Create an Angular Spreadsheet Application

Install the @angular/cli package.

npm i -g @angular/cli

Create a new Angular project. In this example, we will be using Angular v16.

ng new spreadjs-angular-io
cd spreadjs-angular-io

Install the npm packages for SpreadJS:

npm install @mescius/spread-sheets @mescius/spread-sheets-angular @mescius/spread-sheets-io @mescius/spread-sheets-charts @mescius/spread-sheets-shapes

Open the angular.json file and add SpreadJS CSS to the global styles node (as shown below). This applies one of the built-in themes, changing the UI of the spreadsheet instance—refer to our demo for more details.

…  
"projects": {
    "spreadjs-angular-io": {
      …
      "architect": {
        "build": {
         …    
           "styles": [
              "src/styles.css",
              "node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2016darkGray.css"
            ],
            …
            }
            …  
          }
          …
        }
        …
      }
    }
    …
 }

Next, open the app.module.ts file and add the necessary imports for the SpreadJS module, as noted below.

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
// Import SpreadJS module
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";

@NgModule({
  declarations: [
    AppComponent
  ],
  // Import SpreadJS module
  imports: [
    BrowserModule, SpreadSheetsModule
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }

Open the app.componet.html file and delete the placeholder content. Then add SpreadJS’ Angular Template to the application, along with buttons for opening, exporting, and modifying the .xlsx file like so:

 <body>
<div class="left-side"><gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="workbookInit($event)">
</gc-spread-sheets>
</div>

<div class="right-side">
    <p>Open Excel File (.xlsx)</p>
    <input id="selectedFile" type="file" name="files[]" multiple id="jsonFile" accept=".xlsx" (change)="selectedFileChange($event)" />
    <button (click)="open()" id="open">Open Excel</button>

    <p>Add Data</p>
    <button (click)="addCustomer()">Add Customer</button>

    <p>Save Excel File</p>
    <button (click)="save()">Save Excel</button>
</div>
</body>

Add the following styling to the projects styles.css file:

body {
    margin: 0;
    padding: 0;
    display: flex;
    height: 100vh;
}

.left-side {
    width: 85%;
    background-color: #f2f2f2;
    padding: 20px;
}

.right-side {
    width: 15%;
    background-color: #ddd;
    padding: 20px;
}

In the app.component.ts file, add the following code to add the Angular spreadsheet component to the application and initialize the workbook.

import { Component } from '@angular/core';
import '@mescius/spread-sheets-angular';
import * as GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-charts';
import '@mescius/spread-sheets-shapes';
//import { saveAs } from 'file-saver';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent {
  title = "SJS-Angular-IO-Excel";
  hostStyle = {
    width: '95%',
    height: '600px'
  };
  private spread;
  columnWidth = 100;
  constructor() {
    this.spread = new GC.Spread.Sheets.Workbook();
  }
  // Initialize SpreadJS
  workbookInit($event: any) {
    this.spread = $event.spread;
  }
  // Get the selected Excel file
  selectedFileChange(e: any) {
  }
  // Imported the Excel file into SpreadJS
  open() {
  }
  // Modify data imported
  addCustomer() {
  }
  // Save the instance as an Excel File
  save() {
  }
}

Save all the files, and run the Angular app:

npm start

You have now created an Angular Spreadsheet app:

Import/Export Excel/XLSX Angular


Add Excel Import Code to an Angular App

SpreadJS has a workbook import method that imports the object state from Excel. Before we can invoke this method, we must get the user-selected .xlsx file. To do this, we will go to the app.componet.ts file, and add selectedFile variable:

export class AppComponent {
  title = "SJS-Angular-IO-Excel";
  hostStyle = {
    width: '95%',
    height: '600px'
  };
  private spread;
  columnWidth = 100;
   
   // Stores the user-selected file in the selectedFileChange function
  selectedFile: File | any = null;

  constructor() {
    this.spread = new GC.Spread.Sheets.Workbook();
  }
...

In the selectedFileChange function store the selected file object in the selectedFile variable :

// Get the selected Excel file
  selectedFileChange(e: any) {
      this.selectedFile = e.target.files[0];
}

Now, in the open function, with the selectedFile, invoke the SpreadJS import method, be sure to specify the FileType as excel.

open() {
    var file = this.selectedFile;
        if (!file) {
            return;
        }
    // Specify the file type to ensure proper import
    const options: GC.Spread.Sheets.ImportOptions = {
      fileType: GC.Spread.Sheets.FileType.excel
    };

    this.spread.import(file, () => {
      console.log('Import successful');
    }, (e: any) => {
      console.error('Error during import:', e);
    }, options);
  }

With these steps, you've successfully add Excel import functionality to the Angular spreadsheet application.

Import/Export Excel/XLSX Angular


Add Data to the Import Excel File

After successfully importing an Excel file into SpreadJS, you may find it necessary to programmatically modify the data within the spreadsheet. This section introduces the function addCustomer, which adds new customer data to the imported .xlsx file data when a button is clicked. First, we need to create a currentCustomerIndex variable, this will be used as a counter related to the sample data:

export class AppComponent {
  title = "SJS-Angular-IO-Excel";
  hostStyle = {
    width: '95%',
    height: '600px'
  };
  private spread;
  private currentCustomerIndex = 0;
  columnWidth = 100;
   
   // Stores the user-selected file in the selectedFileChange function
  selectedFile: File | any = null;

  constructor() {
    this.spread = new GC.Spread.Sheets.Workbook();
  }
...

Update the addCustomer function to add a new row, copy the styles of the previous row, and apply the new customer data within the customerDataArrays.

// Modify data imported
  addCustomer() {
    // create new row and copy styles
    var newRowIndex = 34;
    var sheet = this.spread.getActiveSheet();
    sheet.addRows(newRowIndex, 1);  
    sheet.copyTo(32, 1, newRowIndex, 1, 1, 11, GC.Spread.Sheets.CopyToOptions.style);  
    // Define sample customer data
    var customerDataArrays = [
        ["Jessica Moth", 5000, 2000, 3000, 1300, 999, 100],
        ["John Doe", 6000, 2500, 3500, 1400, 1000, 20],
        ["Alice Smith", 7000, 3000, 4000, 1500, 1100, 0]
    ];
    // Get the current customer data array
    var currentCustomerData = customerDataArrays[this.currentCustomerIndex];
    // Add new data to the new row
    sheet.setArray(newRowIndex, 5, [currentCustomerData]);
    newRowIndex++;
    // Increment the index for the next button click
    this.currentCustomerIndex = (this.currentCustomerIndex + 1) % customerDataArrays.length;
  }

Notice, that when the button is clicked, new customer data is added to the statement, and the formulas within the worksheet update accordingly.

Modify Data Angular


Add Excel Export Code to an Angular App

With the export method included with SpreadJS and the file-saver npm package, Angular app developers can effortlessly export a spreadsheet state as an Excel file. First, install the file-saver npm package.

npm install file-saver --save
npm i --save-dev @types/file-saver

In the angular.json file, add the file-saver component to the global scripts node.

…  
"projects": {
    "spreadjs-angular-io": {
      …
      "architect": {
        "build": {
         …    
           "styles": [
              "src/styles.css",
              "node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2016darkGray.css"
            ],
            "scripts": ["node_modules/file-saver/dist/FileSaver.js"]
            …
            }
            …  
          }
          …
        }
        …
      }
    }
    …
 }

Import the file-saver package to the app.component.ts file.

import { Component } from '@angular/core';
import '@mescius/spread-sheets-angular';
import * as GC from "@mescius/spread-sheets";
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-charts';
import '@mescius/spread-sheets-shapes';
import { saveAs } from 'file-saver';
...

Next, update the save function by first specifying the exported XLSX file name; we used “Excel_Export.xlsx”, then invoke the SpreadJS export method, which exports the current spreadsheet state into a Blob. Within the export method, invoke the file-saver's saveAs method to save the exported spreadsheet Blob as an actual Excel file on the client side.

  // Save the instance as an Excel File
  save() {
    var fileName = 'Excel_Export.xlsx'
    this.spread.export(function (blob:any) {
      // save blob to a file
      saveAs(blob, fileName);
    }, function (e:any) {
        console.log(e);
    }, {
        fileType: GC.Spread.Sheets.FileType.excel
    });
  }

With these steps, you've successfully added Excel export functionality to the Angular spreadsheet application.

Save Angular Excel File

Don’t forget to download this blog's sample application to try importing/exporting your own Excel files.


Learn More About this Angular Spreadsheet Component

This article only scratches the surface of the full capabilities of SpreadJS, the Angular spreadsheet component. Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code. Integrating a spreadsheet component into your applications allows you to customize your users' experience and provide them with familiar spreadsheet functionality without referring them to an external program.

Ready to Try It Out? Download SpreadJS Today!

To learn more about SpreadJS and the new latest release features, check out our release pages releases and this video:

In another article series, we demonstrate how to import/export Excel (.xlsx) spreadsheets in other frameworks:

comments powered by Disqus

Skip to main content Skip to footer

How to Import and Export Excel XLSX Using Vue

Quick Start Guide
Tutorial Concept Learn how to import, modify, and export Excel (.xlsx) files in Vue applications.
What You Will Need

Vue App
NPM Packages:

Controls Referenced

SpreadJS - Vue Spreadsheet Component
Documentation | Demos

This article demonstrates how software developers can add importing and exporting Excel file capabilities to their Vue applications using a Vue spreadsheet component and API library. This example utilizes SpreadJS, a popular enterprise-level Vue spreadsheet component, which offer a familiar Excel-like spreadsheet UI and import/export capabilities without any dependencies on Microsoft Excel.

Want to test exporting Excel File from You Vue Application? Download a Free Trial of SpreadJS Today!

Steps to Import & Export Excel (.XLSX) from Vue Apps

  1. Create a Vue Spreadsheet Application
  2. Add Excel Import Code
  3. Add Data to the Import Excel File
  4. Add Excel Export Code

Import and Export Excel .XLSX from Vue applications

Download a finished sample application to follow along with the tutorial.

Create a Vue Spreadsheet Application

Using the following command create a simple Vue project. This command will run create-vue, the Vue scaffolding tool, with optional prompts for features like TypeScript and testing support.

npm create vue@latest 

Note, you will be given several optional features such as TypeScript and Testing Support:

Vue Project Set-Up

After creating the project, use the following commands to navigate to the project directory and install the necessary NPM dependencies for SpreadJS and File-Saver.

cd vue-io-xlsx
npm install
npm install @mescius/spread-sheets @mescius/spread-sheets-vue @mescius/spread-sheets-io @mescius/spread-sheets-charts @mescius/spread-sheets-shapes
npm install file-saver --save

Update the main.js file to integrate the spreadsheet components by replacing its content with the code below. This will enable the use of GcSpreadSheets, GcWorksheet, and GcColumn components throughout your application.

import { createApp } from "vue";
import App from "./App.vue";
import {
  GcSpreadSheets,
  GcWorksheet,
  GcColumn,
} from "@mescius/spread-sheets-vue";

let app = createApp(App);
app.component("gc-spread-sheets", GcSpreadSheets);
app.component("gc-worksheet", GcWorksheet);
app.component("gc-column", GcColumn);
app.mount("#app");

Next, update the App.vue file's template to render the host element for SpreadJS and create options for interacting with the Excel files, including import, modifying, and saving to Excel. 

<template>
  <div class="spreadsheet-container">
    <gc-spread-sheets class="spread-host" @workbookInitialized="initSpread">
    </gc-spread-sheets>
    <div class="options-container">
      <div class="option-row">
        <div class="inputContainer">
          <p>Open Excel File (.xlsx)</p>
          <input type="file" id="fileDemo" class="input" @change="changeFileDemo" />
          <input type="button" id="loadExcel" value="Open Excel" class="button" @click="loadExcel" />
          <p>Add Data</p>
          <input type="button" id="saveExcel" value="Add Revenue" class="button" @click="modifyExcel" />
          <p>Save Excel File (.xlsx)</p>
          <input id="exportFileName" value="export.xlsx" class="input" @change="changeExportFileName" />
          <input type="button" id="saveExcel" value="Save Excel" class="button" @click="saveExcel" />
        </div>
      </div>
    </div>
  </div>
</template>

After the template, within the script tags, declare the imports of the needed SpreadJS and File-Saver components. These imports will enable access to the Vue spreadsheet object of the SpreadJS library and support for charts, shapes, and import/export to/from the spreadsheet instance.

import "@mescius/spread-sheets/styles/gc.spread.sheets.excel2016colorful.css";
import * as GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-io";
import { saveAs } from "file-saver";

In App.vue, define the component options to initialize the Vue Spreadsheet and handle Excel files. The initSpread method initializes the Vue spreadsheet instance, while there are placeholders for loadExcel, modifyExcel, and saveExcel methods. We will cover these file operations in the later sections.

export default {
  name: "App",
  methods: {
    // Initialize the Vue Spreadsheet Instance
    initSpread: function (spread) {
      this.spread = spread;
      let sheet = this.spread.getActiveSheet();
      this.revenueCount = 8;
      this.newRowIndex = 11;
    },
    changeFileDemo(e) {
      this.importExcelFile = e.target.files[0];
    },
    changeExportFileName(e) {
      this.exportFileName = e.target.value;
    },
    loadExcel() {
    // Load an existing Excel file into the Vue spreadsheet app
    },
    modifyExcel() {
    // Modify the import Excel file within the Vue instance
      },
    saveExcel() {
    // Save Vue spreadsheet to local Excel XLSX file
    },
  },
};

Save all of the files, and run the Vue app.

npm run build

You have now created a Vue spreadsheet application.

Vue Spreadsheet Component with Import/Export Excel capabilities


Add Excel Import Code to a Vue Application

Invoke the SpreadJS Workbook's import method within the loadExcel method to read the user selected Excel file into the Vue spreadsheet object and display it within the UI.

    loadExcel() {
      let spread = this.spread;
      let excelFile = this.importExcelFile;
      let options = {
        fileType: GC.Spread.Sheets.FileType.excel,
      };
      // Import an existing Excel file to Vue spreadsheet
      spread.import(
        excelFile,
        () => {
          console.log("Import successful");
        },
        (e) => {
          console.error("Error during import:", e);
        },
        options
      );
    },

 You can do the same thing with an Excel file on a server by reading it from a URL.

An Excel (.xlsx) file can now be imported, viewed, and modified within the Vue spreadsheet component.

Import Excel (.xlsx) into Vue applications


Add Data to the Imported Excel File

In this tutorial we will use the “Profit loss statement” Excel template seen here:

Sample Excel file for this tutorial on importing and export EXCEL

Within the modifyExcel method, developers can programmatically add a new row to the spreadsheet, fill it with revenue data, add the sparkline visualization, and set a formula to calculate the sum for the year.

modifyExcel() {
    let spread = this.spread;
    let sheet = spread.getActiveSheet();
    // Add a new row for the next revenue item
    sheet.addRows(this.newRowIndex, 1);
    // Copy styles from an existing row
    sheet.copyTo(10, 1, this.newRowIndex, 1, 1, 29, GC.Spread.Sheets.CopyToOptions.style);
    // Set the new row's first column with the revenue label
    var cellText = ("Revenue " + this.revenueCount++);
    sheet.setValue(this.newRowIndex, 1, cellText);
    // Fill the row with random revenue data
    for (var c = 3; c < 15; c++) {
        sheet.setValue(this.newRowIndex, c, Math.floor(Math.random() * 200) + 10);
    }
    // Add a sparkline chart for the revenue data
    var data = new GC.Spread.Sheets.Range(this.newRowIndex, 3, 1, 12);
    var setting = new GC.Spread.Sheets.Sparklines.SparklineSetting();
    setting.options.seriesColor = "Text 2";
    setting.options.lineWeight = 1;
    setting.options.showLow = true;
    setting.options.showHigh = true;
    setting.options.lowMarkerColor = "Text 2";
    setting.options.highMarkerColor = "Text 1";
    sheet.setSparkline(this.newRowIndex, 2, data, GC.Spread.Sheets.Sparklines.DataOrientation.horizontal, GC.Spread.Sheets.Sparklines.SparklineType.line, setting);
    // Add a formula to calculate the sum for the new row's year data
    sheet.setFormula(this.newRowIndex, 15, "=SUM([@[Jan]:[Dec]])");
    // Move to the next row for future modifications
    this.newRowIndex++;
    // Set a fixed value in the next column
    sheet.setValue(this.newRowIndex, 16, 0.15);
    // Copy formula settings to other parts of the row
    sheet.copyTo(10, 17, this.newRowIndex, 17, 1, 13, GC.Spread.Sheets.CopyToOptions.formula);
},

Notice, with this code logic applied the new row of revenue data is added cohesively to the existing Vue spreadsheet data. 

Add Data to an Import Excel File in Vue App


Add Excel Export Code to a Vue Application

Invoke the SpreadJS Workbook's export method within the saveExcel method to save the modified Vue spreadsheet data to a local Excel .xlsx file.

saveExcel() {
      let spread = this.spread;
      var fileName = "Excel_Export.xlsx";
      // Save Vue spreadsheet to local Excel XLSX file
      spread.export(
        function (blob) {
          // save blob to a file
          saveAs(blob, fileName);
        },
        function (e) {
          console.log(e);
        },
        {
          fileType: GC.Spread.Sheets.FileType.excel,
        }
      );
    },

The exported Excel file contains the modified data and keeps the same formatting and styling as seen in the Vue app display, and from the originally imported Excel file.

Export Vue Spreadsheets to Excel .XLSX


Learn More About this Vue Spreadsheet Component

This article only scratches the surface of the full capabilities of SpreadJS, the Vue spreadsheet component. Review the documentation to see some of the many available features, and check out our online demos to see the features in action and interact with the sample code. Integrating a spreadsheet component into your applications allows you to customize your users' experience and provide them with familiar spreadsheet functionality without referring them to an external program. To learn more about SpreadJS and the new features added in the latest release check out our release pages and this video:

In another article series, we demonstrate how to export Excel in other frameworks:

Want to test exporting Excel in Your Vue Application? Download a Trial Now!

Tags:

comments powered by Disqus